#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "M_skill.h"
#include "FileEncrypt.h"
std::auto_ptr<M_skill> M_skill::msSingleton(nullptr);

int M_skill::GetCount()
{
	return (int)mMapData.size();
}

const M_skillData* M_skill::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, M_skillData>& M_skill::GetMapData()
{
	return mMapData;
}

void M_skill::Reload()
{
	mMapData.clear();
	Load();
}

void M_skill::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_skillData data;
		data.mID = element->IntAttribute("ID");
		data.mhero_id = element->IntAttribute("hero_id");
		data.mskill_leve = element->IntAttribute("skill_leve");
		data.mbullet_num = element->IntAttribute("bullet_num");
		data.mbullet_radius = element->IntAttribute("bullet_radius");
		data.mattack_distance = element->IntAttribute("attack_distance");
		data.mskill_des = element->Attribute("skill_des");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		assert(mMapData.find(data.mID) == mMapData.end());
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
}

void M_skill::Load()
{
	Load("../Config/M_skill.xml");
}

M_skill* M_skill::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_skill());
	}
	return msSingleton.get();
}
